import type { BaseContract, BigNumber, BigNumberish, BytesLike, CallOverrides, ContractTransaction, Overrides, PayableOverrides, PopulatedTransaction, Signer, utils } from "ethers";
import type { FunctionFragment, Result, EventFragment } from "@ethersproject/abi";
import type { Listener, Provider } from "@ethersproject/providers";
import type { TypedEventFilter, TypedEvent, TypedListener, OnEvent, PromiseOrValue } from "../../../../../common";
export type HarvestSwapParamsStruct = {
    path: PromiseOrValue<string>[];
    min: PromiseOrValue<BigNumberish>;
    deadline: PromiseOrValue<BigNumberish>;
    pathData: PromiseOrValue<BytesLike>;
};
export type HarvestSwapParamsStructOutput = [
    string[],
    BigNumber,
    BigNumber,
    string
] & {
    path: string[];
    min: BigNumber;
    deadline: BigNumber;
    pathData: string;
};
export interface ISuperComposableYieldInterface extends utils.Interface {
    functions: {
        "MIN_LIQUIDITY()": FunctionFragment;
        "acceptsNativeToken()": FunctionFragment;
        "assetInfo()": FunctionFragment;
        "closePosition(uint256,uint256)": FunctionFragment;
        "deposit(address,address,uint256,uint256)": FunctionFragment;
        "depositIntoStrategy(uint256,uint256)": FunctionFragment;
        "exchangeRateUnderlying()": FunctionFragment;
        "getAndUpdateTvl()": FunctionFragment;
        "getBaseTokens()": FunctionFragment;
        "getDepositAmnt(uint256)": FunctionFragment;
        "getFloatingAmount(address)": FunctionFragment;
        "getMaxTvl()": FunctionFragment;
        "getStrategyTvl()": FunctionFragment;
        "getTvl()": FunctionFragment;
        "getUpdatedUnderlyingBalance(address)": FunctionFragment;
        "getWithdrawAmnt(uint256)": FunctionFragment;
        "harvest(uint256,uint256,(address[],uint256,uint256,bytes)[],(address[],uint256,uint256,bytes)[])": FunctionFragment;
        "initStrategy(address)": FunctionFragment;
        "isValidBaseToken(address)": FunctionFragment;
        "pause()": FunctionFragment;
        "redeem(address,uint256,address,uint256)": FunctionFragment;
        "sendERC20ToStrategy()": FunctionFragment;
        "setMaxTvl(uint256)": FunctionFragment;
        "sharesToUnderlying(uint256)": FunctionFragment;
        "strategy()": FunctionFragment;
        "uBalance()": FunctionFragment;
        "underlying()": FunctionFragment;
        "underlyingBalance(address)": FunctionFragment;
        "underlyingDecimals()": FunctionFragment;
        "underlyingToShares(uint256)": FunctionFragment;
        "unpause()": FunctionFragment;
        "withdrawFromStrategy(uint256,uint256)": FunctionFragment;
        "yieldToken()": FunctionFragment;
    };
    getFunction(nameOrSignatureOrTopic: "MIN_LIQUIDITY" | "acceptsNativeToken" | "assetInfo" | "closePosition" | "deposit" | "depositIntoStrategy" | "exchangeRateUnderlying" | "getAndUpdateTvl" | "getBaseTokens" | "getDepositAmnt" | "getFloatingAmount" | "getMaxTvl" | "getStrategyTvl" | "getTvl" | "getUpdatedUnderlyingBalance" | "getWithdrawAmnt" | "harvest" | "initStrategy" | "isValidBaseToken" | "pause" | "redeem" | "sendERC20ToStrategy" | "setMaxTvl" | "sharesToUnderlying" | "strategy" | "uBalance" | "underlying" | "underlyingBalance" | "underlyingDecimals" | "underlyingToShares" | "unpause" | "withdrawFromStrategy" | "yieldToken"): FunctionFragment;
    encodeFunctionData(functionFragment: "MIN_LIQUIDITY", values?: undefined): string;
    encodeFunctionData(functionFragment: "acceptsNativeToken", values?: undefined): string;
    encodeFunctionData(functionFragment: "assetInfo", values?: undefined): string;
    encodeFunctionData(functionFragment: "closePosition", values: [PromiseOrValue<BigNumberish>, PromiseOrValue<BigNumberish>]): string;
    encodeFunctionData(functionFragment: "deposit", values: [
        PromiseOrValue<string>,
        PromiseOrValue<string>,
        PromiseOrValue<BigNumberish>,
        PromiseOrValue<BigNumberish>
    ]): string;
    encodeFunctionData(functionFragment: "depositIntoStrategy", values: [PromiseOrValue<BigNumberish>, PromiseOrValue<BigNumberish>]): string;
    encodeFunctionData(functionFragment: "exchangeRateUnderlying", values?: undefined): string;
    encodeFunctionData(functionFragment: "getAndUpdateTvl", values?: undefined): string;
    encodeFunctionData(functionFragment: "getBaseTokens", values?: undefined): string;
    encodeFunctionData(functionFragment: "getDepositAmnt", values: [PromiseOrValue<BigNumberish>]): string;
    encodeFunctionData(functionFragment: "getFloatingAmount", values: [PromiseOrValue<string>]): string;
    encodeFunctionData(functionFragment: "getMaxTvl", values?: undefined): string;
    encodeFunctionData(functionFragment: "getStrategyTvl", values?: undefined): string;
    encodeFunctionData(functionFragment: "getTvl", values?: undefined): string;
    encodeFunctionData(functionFragment: "getUpdatedUnderlyingBalance", values: [PromiseOrValue<string>]): string;
    encodeFunctionData(functionFragment: "getWithdrawAmnt", values: [PromiseOrValue<BigNumberish>]): string;
    encodeFunctionData(functionFragment: "harvest", values: [
        PromiseOrValue<BigNumberish>,
        PromiseOrValue<BigNumberish>,
        HarvestSwapParamsStruct[],
        HarvestSwapParamsStruct[]
    ]): string;
    encodeFunctionData(functionFragment: "initStrategy", values: [PromiseOrValue<string>]): string;
    encodeFunctionData(functionFragment: "isValidBaseToken", values: [PromiseOrValue<string>]): string;
    encodeFunctionData(functionFragment: "pause", values?: undefined): string;
    encodeFunctionData(functionFragment: "redeem", values: [
        PromiseOrValue<string>,
        PromiseOrValue<BigNumberish>,
        PromiseOrValue<string>,
        PromiseOrValue<BigNumberish>
    ]): string;
    encodeFunctionData(functionFragment: "sendERC20ToStrategy", values?: undefined): string;
    encodeFunctionData(functionFragment: "setMaxTvl", values: [PromiseOrValue<BigNumberish>]): string;
    encodeFunctionData(functionFragment: "sharesToUnderlying", values: [PromiseOrValue<BigNumberish>]): string;
    encodeFunctionData(functionFragment: "strategy", values?: undefined): string;
    encodeFunctionData(functionFragment: "uBalance", values?: undefined): string;
    encodeFunctionData(functionFragment: "underlying", values?: undefined): string;
    encodeFunctionData(functionFragment: "underlyingBalance", values: [PromiseOrValue<string>]): string;
    encodeFunctionData(functionFragment: "underlyingDecimals", values?: undefined): string;
    encodeFunctionData(functionFragment: "underlyingToShares", values: [PromiseOrValue<BigNumberish>]): string;
    encodeFunctionData(functionFragment: "unpause", values?: undefined): string;
    encodeFunctionData(functionFragment: "withdrawFromStrategy", values: [PromiseOrValue<BigNumberish>, PromiseOrValue<BigNumberish>]): string;
    encodeFunctionData(functionFragment: "yieldToken", values?: undefined): string;
    decodeFunctionResult(functionFragment: "MIN_LIQUIDITY", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "acceptsNativeToken", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "assetInfo", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "closePosition", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "deposit", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "depositIntoStrategy", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "exchangeRateUnderlying", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "getAndUpdateTvl", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "getBaseTokens", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "getDepositAmnt", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "getFloatingAmount", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "getMaxTvl", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "getStrategyTvl", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "getTvl", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "getUpdatedUnderlyingBalance", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "getWithdrawAmnt", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "harvest", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "initStrategy", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "isValidBaseToken", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "pause", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "redeem", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "sendERC20ToStrategy", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "setMaxTvl", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "sharesToUnderlying", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "strategy", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "uBalance", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "underlying", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "underlyingBalance", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "underlyingDecimals", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "underlyingToShares", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "unpause", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "withdrawFromStrategy", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "yieldToken", data: BytesLike): Result;
    events: {
        "Deposit(address,address,address,uint256,uint256)": EventFragment;
        "ExchangeRateUpdated(uint256,uint256)": EventFragment;
        "Redeem(address,address,address,uint256,uint256)": EventFragment;
    };
    getEvent(nameOrSignatureOrTopic: "Deposit"): EventFragment;
    getEvent(nameOrSignatureOrTopic: "ExchangeRateUpdated"): EventFragment;
    getEvent(nameOrSignatureOrTopic: "Redeem"): EventFragment;
}
export interface DepositEventObject {
    caller: string;
    receiver: string;
    tokenIn: string;
    amountDeposited: BigNumber;
    amountScyOut: BigNumber;
}
export type DepositEvent = TypedEvent<[
    string,
    string,
    string,
    BigNumber,
    BigNumber
], DepositEventObject>;
export type DepositEventFilter = TypedEventFilter<DepositEvent>;
export interface ExchangeRateUpdatedEventObject {
    oldExchangeRate: BigNumber;
    newExchangeRate: BigNumber;
}
export type ExchangeRateUpdatedEvent = TypedEvent<[
    BigNumber,
    BigNumber
], ExchangeRateUpdatedEventObject>;
export type ExchangeRateUpdatedEventFilter = TypedEventFilter<ExchangeRateUpdatedEvent>;
export interface RedeemEventObject {
    caller: string;
    receiver: string;
    tokenOut: string;
    amountScyToRedeem: BigNumber;
    amountTokenOut: BigNumber;
}
export type RedeemEvent = TypedEvent<[
    string,
    string,
    string,
    BigNumber,
    BigNumber
], RedeemEventObject>;
export type RedeemEventFilter = TypedEventFilter<RedeemEvent>;
export interface ISuperComposableYield extends BaseContract {
    connect(signerOrProvider: Signer | Provider | string): this;
    attach(addressOrName: string): this;
    deployed(): Promise<this>;
    interface: ISuperComposableYieldInterface;
    queryFilter<TEvent extends TypedEvent>(event: TypedEventFilter<TEvent>, fromBlockOrBlockhash?: string | number | undefined, toBlock?: string | number | undefined): Promise<Array<TEvent>>;
    listeners<TEvent extends TypedEvent>(eventFilter?: TypedEventFilter<TEvent>): Array<TypedListener<TEvent>>;
    listeners(eventName?: string): Array<Listener>;
    removeAllListeners<TEvent extends TypedEvent>(eventFilter: TypedEventFilter<TEvent>): this;
    removeAllListeners(eventName?: string): this;
    off: OnEvent<this>;
    on: OnEvent<this>;
    once: OnEvent<this>;
    removeListener: OnEvent<this>;
    functions: {
        MIN_LIQUIDITY(overrides?: CallOverrides): Promise<[BigNumber]>;
        acceptsNativeToken(overrides?: CallOverrides): Promise<[boolean]>;
        assetInfo(overrides?: CallOverrides): Promise<[
            number,
            string,
            number
        ] & {
            assetType: number;
            assetAddress: string;
            assetDecimals: number;
        }>;
        closePosition(minAmountOut: PromiseOrValue<BigNumberish>, slippageParam: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<ContractTransaction>;
        deposit(receiver: PromiseOrValue<string>, tokenIn: PromiseOrValue<string>, amountTokenToPull: PromiseOrValue<BigNumberish>, minSharesOut: PromiseOrValue<BigNumberish>, overrides?: PayableOverrides & {
            from?: PromiseOrValue<string>;
        }): Promise<ContractTransaction>;
        depositIntoStrategy(amount: PromiseOrValue<BigNumberish>, minSharesOut: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<ContractTransaction>;
        exchangeRateUnderlying(overrides?: CallOverrides): Promise<[BigNumber]>;
        getAndUpdateTvl(overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<ContractTransaction>;
        getBaseTokens(overrides?: CallOverrides): Promise<[string[]] & {
            res: string[];
        }>;
        getDepositAmnt(amount: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<[BigNumber]>;
        getFloatingAmount(arg0: PromiseOrValue<string>, overrides?: CallOverrides): Promise<[BigNumber]>;
        getMaxTvl(overrides?: CallOverrides): Promise<[BigNumber]>;
        getStrategyTvl(overrides?: CallOverrides): Promise<[BigNumber]>;
        getTvl(overrides?: CallOverrides): Promise<[BigNumber] & {
            tvl: BigNumber;
        }>;
        getUpdatedUnderlyingBalance(arg0: PromiseOrValue<string>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<ContractTransaction>;
        getWithdrawAmnt(amount: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<[BigNumber]>;
        harvest(expectedTvl: PromiseOrValue<BigNumberish>, maxDelta: PromiseOrValue<BigNumberish>, swap1: HarvestSwapParamsStruct[], swap2: HarvestSwapParamsStruct[], overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<ContractTransaction>;
        initStrategy(arg0: PromiseOrValue<string>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<ContractTransaction>;
        isValidBaseToken(token: PromiseOrValue<string>, overrides?: CallOverrides): Promise<[boolean]>;
        pause(overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<ContractTransaction>;
        redeem(receiver: PromiseOrValue<string>, amountSharesToPull: PromiseOrValue<BigNumberish>, tokenOut: PromiseOrValue<string>, minTokenOut: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<ContractTransaction>;
        sendERC20ToStrategy(overrides?: CallOverrides): Promise<[boolean]>;
        setMaxTvl(arg0: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<ContractTransaction>;
        sharesToUnderlying(shares: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<[BigNumber]>;
        strategy(overrides?: CallOverrides): Promise<[string]>;
        uBalance(overrides?: CallOverrides): Promise<[BigNumber]>;
        underlying(overrides?: CallOverrides): Promise<[string]>;
        underlyingBalance(arg0: PromiseOrValue<string>, overrides?: CallOverrides): Promise<[BigNumber]>;
        underlyingDecimals(overrides?: CallOverrides): Promise<[number]>;
        underlyingToShares(amnt: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<[BigNumber]>;
        unpause(overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<ContractTransaction>;
        withdrawFromStrategy(shares: PromiseOrValue<BigNumberish>, minAmountOut: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<ContractTransaction>;
        yieldToken(overrides?: CallOverrides): Promise<[string]>;
    };
    MIN_LIQUIDITY(overrides?: CallOverrides): Promise<BigNumber>;
    acceptsNativeToken(overrides?: CallOverrides): Promise<boolean>;
    assetInfo(overrides?: CallOverrides): Promise<[
        number,
        string,
        number
    ] & {
        assetType: number;
        assetAddress: string;
        assetDecimals: number;
    }>;
    closePosition(minAmountOut: PromiseOrValue<BigNumberish>, slippageParam: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
        from?: PromiseOrValue<string>;
    }): Promise<ContractTransaction>;
    deposit(receiver: PromiseOrValue<string>, tokenIn: PromiseOrValue<string>, amountTokenToPull: PromiseOrValue<BigNumberish>, minSharesOut: PromiseOrValue<BigNumberish>, overrides?: PayableOverrides & {
        from?: PromiseOrValue<string>;
    }): Promise<ContractTransaction>;
    depositIntoStrategy(amount: PromiseOrValue<BigNumberish>, minSharesOut: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
        from?: PromiseOrValue<string>;
    }): Promise<ContractTransaction>;
    exchangeRateUnderlying(overrides?: CallOverrides): Promise<BigNumber>;
    getAndUpdateTvl(overrides?: Overrides & {
        from?: PromiseOrValue<string>;
    }): Promise<ContractTransaction>;
    getBaseTokens(overrides?: CallOverrides): Promise<string[]>;
    getDepositAmnt(amount: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<BigNumber>;
    getFloatingAmount(arg0: PromiseOrValue<string>, overrides?: CallOverrides): Promise<BigNumber>;
    getMaxTvl(overrides?: CallOverrides): Promise<BigNumber>;
    getStrategyTvl(overrides?: CallOverrides): Promise<BigNumber>;
    getTvl(overrides?: CallOverrides): Promise<BigNumber>;
    getUpdatedUnderlyingBalance(arg0: PromiseOrValue<string>, overrides?: Overrides & {
        from?: PromiseOrValue<string>;
    }): Promise<ContractTransaction>;
    getWithdrawAmnt(amount: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<BigNumber>;
    harvest(expectedTvl: PromiseOrValue<BigNumberish>, maxDelta: PromiseOrValue<BigNumberish>, swap1: HarvestSwapParamsStruct[], swap2: HarvestSwapParamsStruct[], overrides?: Overrides & {
        from?: PromiseOrValue<string>;
    }): Promise<ContractTransaction>;
    initStrategy(arg0: PromiseOrValue<string>, overrides?: Overrides & {
        from?: PromiseOrValue<string>;
    }): Promise<ContractTransaction>;
    isValidBaseToken(token: PromiseOrValue<string>, overrides?: CallOverrides): Promise<boolean>;
    pause(overrides?: Overrides & {
        from?: PromiseOrValue<string>;
    }): Promise<ContractTransaction>;
    redeem(receiver: PromiseOrValue<string>, amountSharesToPull: PromiseOrValue<BigNumberish>, tokenOut: PromiseOrValue<string>, minTokenOut: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
        from?: PromiseOrValue<string>;
    }): Promise<ContractTransaction>;
    sendERC20ToStrategy(overrides?: CallOverrides): Promise<boolean>;
    setMaxTvl(arg0: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
        from?: PromiseOrValue<string>;
    }): Promise<ContractTransaction>;
    sharesToUnderlying(shares: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<BigNumber>;
    strategy(overrides?: CallOverrides): Promise<string>;
    uBalance(overrides?: CallOverrides): Promise<BigNumber>;
    underlying(overrides?: CallOverrides): Promise<string>;
    underlyingBalance(arg0: PromiseOrValue<string>, overrides?: CallOverrides): Promise<BigNumber>;
    underlyingDecimals(overrides?: CallOverrides): Promise<number>;
    underlyingToShares(amnt: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<BigNumber>;
    unpause(overrides?: Overrides & {
        from?: PromiseOrValue<string>;
    }): Promise<ContractTransaction>;
    withdrawFromStrategy(shares: PromiseOrValue<BigNumberish>, minAmountOut: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
        from?: PromiseOrValue<string>;
    }): Promise<ContractTransaction>;
    yieldToken(overrides?: CallOverrides): Promise<string>;
    callStatic: {
        MIN_LIQUIDITY(overrides?: CallOverrides): Promise<BigNumber>;
        acceptsNativeToken(overrides?: CallOverrides): Promise<boolean>;
        assetInfo(overrides?: CallOverrides): Promise<[
            number,
            string,
            number
        ] & {
            assetType: number;
            assetAddress: string;
            assetDecimals: number;
        }>;
        closePosition(minAmountOut: PromiseOrValue<BigNumberish>, slippageParam: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<void>;
        deposit(receiver: PromiseOrValue<string>, tokenIn: PromiseOrValue<string>, amountTokenToPull: PromiseOrValue<BigNumberish>, minSharesOut: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<BigNumber>;
        depositIntoStrategy(amount: PromiseOrValue<BigNumberish>, minSharesOut: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<void>;
        exchangeRateUnderlying(overrides?: CallOverrides): Promise<BigNumber>;
        getAndUpdateTvl(overrides?: CallOverrides): Promise<BigNumber>;
        getBaseTokens(overrides?: CallOverrides): Promise<string[]>;
        getDepositAmnt(amount: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<BigNumber>;
        getFloatingAmount(arg0: PromiseOrValue<string>, overrides?: CallOverrides): Promise<BigNumber>;
        getMaxTvl(overrides?: CallOverrides): Promise<BigNumber>;
        getStrategyTvl(overrides?: CallOverrides): Promise<BigNumber>;
        getTvl(overrides?: CallOverrides): Promise<BigNumber>;
        getUpdatedUnderlyingBalance(arg0: PromiseOrValue<string>, overrides?: CallOverrides): Promise<BigNumber>;
        getWithdrawAmnt(amount: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<BigNumber>;
        harvest(expectedTvl: PromiseOrValue<BigNumberish>, maxDelta: PromiseOrValue<BigNumberish>, swap1: HarvestSwapParamsStruct[], swap2: HarvestSwapParamsStruct[], overrides?: CallOverrides): Promise<[
            BigNumber[],
            BigNumber[]
        ] & {
            harvest1: BigNumber[];
            harvest2: BigNumber[];
        }>;
        initStrategy(arg0: PromiseOrValue<string>, overrides?: CallOverrides): Promise<void>;
        isValidBaseToken(token: PromiseOrValue<string>, overrides?: CallOverrides): Promise<boolean>;
        pause(overrides?: CallOverrides): Promise<void>;
        redeem(receiver: PromiseOrValue<string>, amountSharesToPull: PromiseOrValue<BigNumberish>, tokenOut: PromiseOrValue<string>, minTokenOut: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<BigNumber>;
        sendERC20ToStrategy(overrides?: CallOverrides): Promise<boolean>;
        setMaxTvl(arg0: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<void>;
        sharesToUnderlying(shares: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<BigNumber>;
        strategy(overrides?: CallOverrides): Promise<string>;
        uBalance(overrides?: CallOverrides): Promise<BigNumber>;
        underlying(overrides?: CallOverrides): Promise<string>;
        underlyingBalance(arg0: PromiseOrValue<string>, overrides?: CallOverrides): Promise<BigNumber>;
        underlyingDecimals(overrides?: CallOverrides): Promise<number>;
        underlyingToShares(amnt: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<BigNumber>;
        unpause(overrides?: CallOverrides): Promise<void>;
        withdrawFromStrategy(shares: PromiseOrValue<BigNumberish>, minAmountOut: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<void>;
        yieldToken(overrides?: CallOverrides): Promise<string>;
    };
    filters: {
        "Deposit(address,address,address,uint256,uint256)"(caller?: PromiseOrValue<string> | null, receiver?: PromiseOrValue<string> | null, tokenIn?: PromiseOrValue<string> | null, amountDeposited?: null, amountScyOut?: null): DepositEventFilter;
        Deposit(caller?: PromiseOrValue<string> | null, receiver?: PromiseOrValue<string> | null, tokenIn?: PromiseOrValue<string> | null, amountDeposited?: null, amountScyOut?: null): DepositEventFilter;
        "ExchangeRateUpdated(uint256,uint256)"(oldExchangeRate?: null, newExchangeRate?: null): ExchangeRateUpdatedEventFilter;
        ExchangeRateUpdated(oldExchangeRate?: null, newExchangeRate?: null): ExchangeRateUpdatedEventFilter;
        "Redeem(address,address,address,uint256,uint256)"(caller?: PromiseOrValue<string> | null, receiver?: PromiseOrValue<string> | null, tokenOut?: PromiseOrValue<string> | null, amountScyToRedeem?: null, amountTokenOut?: null): RedeemEventFilter;
        Redeem(caller?: PromiseOrValue<string> | null, receiver?: PromiseOrValue<string> | null, tokenOut?: PromiseOrValue<string> | null, amountScyToRedeem?: null, amountTokenOut?: null): RedeemEventFilter;
    };
    estimateGas: {
        MIN_LIQUIDITY(overrides?: CallOverrides): Promise<BigNumber>;
        acceptsNativeToken(overrides?: CallOverrides): Promise<BigNumber>;
        assetInfo(overrides?: CallOverrides): Promise<BigNumber>;
        closePosition(minAmountOut: PromiseOrValue<BigNumberish>, slippageParam: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<BigNumber>;
        deposit(receiver: PromiseOrValue<string>, tokenIn: PromiseOrValue<string>, amountTokenToPull: PromiseOrValue<BigNumberish>, minSharesOut: PromiseOrValue<BigNumberish>, overrides?: PayableOverrides & {
            from?: PromiseOrValue<string>;
        }): Promise<BigNumber>;
        depositIntoStrategy(amount: PromiseOrValue<BigNumberish>, minSharesOut: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<BigNumber>;
        exchangeRateUnderlying(overrides?: CallOverrides): Promise<BigNumber>;
        getAndUpdateTvl(overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<BigNumber>;
        getBaseTokens(overrides?: CallOverrides): Promise<BigNumber>;
        getDepositAmnt(amount: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<BigNumber>;
        getFloatingAmount(arg0: PromiseOrValue<string>, overrides?: CallOverrides): Promise<BigNumber>;
        getMaxTvl(overrides?: CallOverrides): Promise<BigNumber>;
        getStrategyTvl(overrides?: CallOverrides): Promise<BigNumber>;
        getTvl(overrides?: CallOverrides): Promise<BigNumber>;
        getUpdatedUnderlyingBalance(arg0: PromiseOrValue<string>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<BigNumber>;
        getWithdrawAmnt(amount: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<BigNumber>;
        harvest(expectedTvl: PromiseOrValue<BigNumberish>, maxDelta: PromiseOrValue<BigNumberish>, swap1: HarvestSwapParamsStruct[], swap2: HarvestSwapParamsStruct[], overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<BigNumber>;
        initStrategy(arg0: PromiseOrValue<string>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<BigNumber>;
        isValidBaseToken(token: PromiseOrValue<string>, overrides?: CallOverrides): Promise<BigNumber>;
        pause(overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<BigNumber>;
        redeem(receiver: PromiseOrValue<string>, amountSharesToPull: PromiseOrValue<BigNumberish>, tokenOut: PromiseOrValue<string>, minTokenOut: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<BigNumber>;
        sendERC20ToStrategy(overrides?: CallOverrides): Promise<BigNumber>;
        setMaxTvl(arg0: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<BigNumber>;
        sharesToUnderlying(shares: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<BigNumber>;
        strategy(overrides?: CallOverrides): Promise<BigNumber>;
        uBalance(overrides?: CallOverrides): Promise<BigNumber>;
        underlying(overrides?: CallOverrides): Promise<BigNumber>;
        underlyingBalance(arg0: PromiseOrValue<string>, overrides?: CallOverrides): Promise<BigNumber>;
        underlyingDecimals(overrides?: CallOverrides): Promise<BigNumber>;
        underlyingToShares(amnt: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<BigNumber>;
        unpause(overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<BigNumber>;
        withdrawFromStrategy(shares: PromiseOrValue<BigNumberish>, minAmountOut: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<BigNumber>;
        yieldToken(overrides?: CallOverrides): Promise<BigNumber>;
    };
    populateTransaction: {
        MIN_LIQUIDITY(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        acceptsNativeToken(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        assetInfo(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        closePosition(minAmountOut: PromiseOrValue<BigNumberish>, slippageParam: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<PopulatedTransaction>;
        deposit(receiver: PromiseOrValue<string>, tokenIn: PromiseOrValue<string>, amountTokenToPull: PromiseOrValue<BigNumberish>, minSharesOut: PromiseOrValue<BigNumberish>, overrides?: PayableOverrides & {
            from?: PromiseOrValue<string>;
        }): Promise<PopulatedTransaction>;
        depositIntoStrategy(amount: PromiseOrValue<BigNumberish>, minSharesOut: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<PopulatedTransaction>;
        exchangeRateUnderlying(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        getAndUpdateTvl(overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<PopulatedTransaction>;
        getBaseTokens(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        getDepositAmnt(amount: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        getFloatingAmount(arg0: PromiseOrValue<string>, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        getMaxTvl(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        getStrategyTvl(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        getTvl(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        getUpdatedUnderlyingBalance(arg0: PromiseOrValue<string>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<PopulatedTransaction>;
        getWithdrawAmnt(amount: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        harvest(expectedTvl: PromiseOrValue<BigNumberish>, maxDelta: PromiseOrValue<BigNumberish>, swap1: HarvestSwapParamsStruct[], swap2: HarvestSwapParamsStruct[], overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<PopulatedTransaction>;
        initStrategy(arg0: PromiseOrValue<string>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<PopulatedTransaction>;
        isValidBaseToken(token: PromiseOrValue<string>, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        pause(overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<PopulatedTransaction>;
        redeem(receiver: PromiseOrValue<string>, amountSharesToPull: PromiseOrValue<BigNumberish>, tokenOut: PromiseOrValue<string>, minTokenOut: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<PopulatedTransaction>;
        sendERC20ToStrategy(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        setMaxTvl(arg0: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<PopulatedTransaction>;
        sharesToUnderlying(shares: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        strategy(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        uBalance(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        underlying(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        underlyingBalance(arg0: PromiseOrValue<string>, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        underlyingDecimals(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        underlyingToShares(amnt: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        unpause(overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<PopulatedTransaction>;
        withdrawFromStrategy(shares: PromiseOrValue<BigNumberish>, minAmountOut: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<PopulatedTransaction>;
        yieldToken(overrides?: CallOverrides): Promise<PopulatedTransaction>;
    };
}
